# There may be other solutions.
# It is easier to access the least significant digit of n
# rather than the most significant digit of n, we will start
# from the most significant one.
# So n is increasing if read right to left the sequence of digits
# is increasing.

# One solution: We remember the last digit seen, pass it 
# additional parameter, and require that the next digit to the left is smaller,
# and so on. 

def is_increasing(n):
    return check_increasing(n,10)

def check_increasing(n,d):
    if n == 0:
        return True
    else:
        d0 = n % 10
        return (d0 <= d) and check_increasing(n//10,d0)

print(is_increasing(123378))
print(is_increasing(7))
print(is_increasing(0))
print(is_increasing(125433))

# Another solution: We don't pass the parameter.
# We check the two last digits instead.
# Equally good. It does twice as many arithmetic operations, though.

def is_increasing2(n):
    if n == 0:
        return True
    else:
        d0 = n % 10
        d1 = (n//10) % 10
        return (d1 <= d0) and is_increasing2(n//10)

print(is_increasing2(123378))
print(is_increasing2(7))
print(is_increasing2(0))
print(is_increasing2(125433))
