# ok... how do I do this...
# I am going to add an index i, and set it initially to 0 like this
def local_maxima(L):
    return local_maxima_rec(L,0)

# mmm... fine... but what do I do now?
# I know what local_maxima_rec(L,0) should return: the list of local
# maxima of L.
# But, what should local_maxima_rec(L,i) do for values of i?
# Answer: solve a smaller problem. Like, instead of the list of local
# maxima of L, say the list of local maxima of L from i onwards, L[i:]
#
# I am in good shape if I can express local_maxima_rec(L,i)
# by calling local_maxima_rec(L,i+1)
#
# Let us see. can I simply say that local_maxima_rec(L,i)
# equals local_maxima_rec(L,i+1)?
#
# Not really. sometimes I have to add L[i], if it is a local maximum.
# OK. So I compute local_maxima_rec(L,i+1), and then I add L[i]
# at the beginning if L[i] is a local maximum.
#
# L[i] can be a local maxima for three reasons:
# because L[i] is the first element of L, which is always a maximum;
# or because it is not the first element, but it is the last, same reason;
# or because it is an element in between and it is larger than both
# L[i-1] AND L[i+1]

# Now let us organize these 3 cases in python. I can use the case
# "L[i] is the last element" to stop the recursion.
#
# oh yes, I have to take into account the empty list, that does
# not even have a first or a last element. 

def local_maxima_rec(L,i):
    if len(L) == 0:
        return []
    elif i == len(L)-1:  # last element
        return [L[i]]
    elif i == 0: 
        return [L[i]] + local_maxima_rec(L,i+1)
    elif L[i-1] < L[i] and L[i] > L[i+1]:
        return [L[i]] + local_maxima_rec(L,i+1)
    else:
        return local_maxima_rec(L,i+1)

print(local_maxima([]))
print(local_maxima([1]))
print(local_maxima([1,3]))
print(local_maxima([3,1]))
print(local_maxima([1,5,3]))
print(local_maxima([1,2,3]))
print(local_maxima([1,0,3]))
print(local_maxima([3,0,1]))
print(local_maxima([3,4,1]))
print(local_maxima([-1,3,9,2,1,5,2,6,3])) # should be [-1,9,5,6,3]
