# I write 3ced to mean "3 consecutive equal digits"
# here the recursion comes from the following observations:
# - any number that is below 100 does not have 3ced
#   unless of course you count the infinitely many 0 leading 0's,
#   then every number has 3ced, boo.
# - if the last 3 digits are equal, then we know the answer is True
# - if the last 3 digits are not equal... well, we can drop the last
#   digit, and look for the 3ced in the rest of the number. 

def three_consec_equal(n):
    if n == 0:
        return True
    elif n < 1000:
        return False
    else:
        d0 = n%10
        d1 = (n//10)%10
        d2 = (n//100)%10
        return ((d0 == d1) and (d1 == d2)) or three_consec_equal(n//10)

# the last or can also be implemented as an if:
#    if (d0 == d1) and (d1 == d2):
#        return True
#    else:
#        return three_consec_equal(n//10)

print(three_consec_equal(2111))
print(three_consec_equal(3334))
print(three_consec_equal(21113))
print(three_consec_equal(211115666))
print(three_consec_equal(8))
print(three_consec_equal(88))
print(three_consec_equal(8848))

